// PrtThrd.cpp : implementation file
//

#include "stdafx.h"
#include "hexvidoc.h"
#include "prtframe.h"
#include "PrtThrd.h"
#include "mainfrm.h"
#include "hexvivw.h"
#include "hexview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPrintThread

IMPLEMENT_DYNCREATE(CPrintThread, CWinThread)

CPrintThread::CPrintThread()
{
}

CPrintThread::~CPrintThread()
{
}

BOOL CPrintThread::InitInstance()
{
	BOOL bResult = TRUE;

	CHexViewApp* pApp = (CHexViewApp*) AfxGetApp();
	CFrameWnd* pMainWnd = (CFrameWnd*) CWnd::FromHandlePermanent(pApp->m_pMainWnd->m_hWnd);

	CSingleDocTemplate* pTempl = pApp->m_pPrintTempl;
	m_pPrintFrame =	(CPrintFrame*)pTempl->CreateNewFrame(m_pPrintDoc, pMainWnd);

	if (m_pPrintFrame == NULL)
		bResult = FALSE;
	else
	{
		pTempl->InitialUpdateFrame(m_pPrintFrame, m_pPrintDoc);
		m_pMainWnd = m_pPrintFrame;

		POSITION pos = m_pPrintDoc->GetFirstViewPosition();
		if (pos == NULL)
			bResult = FALSE;
		else
		{
			CHexView* pView = (CHexView*) m_pPrintDoc->GetNextView(pos);
			pView->m_bPrintingThread = TRUE;
			pView->OnFilePrint();
		}
		m_pMainWnd->DestroyWindow();
	}

	return bResult;
}

int CPrintThread::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CPrintThread, CWinThread)
	//{{AFX_MSG_MAP(CPrintThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrintThread message handlers
